package things;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * Represents an analog input.
 *
 * @see IO
 */
public class Input extends IO {
    private int value = 0;
    private static InputGenerator generator;

    Input(Thing parent, String name) {
        super(parent, name);
        if (generator == null) {
            generator = new InputGenerator();
        }
        generator.addInput(this);
    }

    @Override
    @JsonView(JSONViews.IODetail.class)
    public int getValue() {
        synchronized (this) {
            return value;
        }
    }

    void setValue(int value) {
        synchronized (this) {
            this.value = value;
        }
    }

    @Override
    public Type getType() {
        return Type.INPUT;
    }
}
